//package straightparse;

abstract class List<a> {
    public abstract <A> A accept (ListVisitor<A,a> v);
}

class NIL<a> extends List<a> {
  public NIL () { }

  public <A> A accept (ListVisitor<A,a> v) {
        return v.visit (this);
  }
}

class CONS<a> extends List<a> {
    public a hd;
    public List<a> tl;
    public CONS (a x, List<a> xs) {
        this.hd = x;
        this.tl = xs;
    }
    public <A> A accept (ListVisitor<A,a> v) {
        return v.visit (this);
    }
}

interface ListVisitor<A,a> {
    public A visit (NIL<a> m);
    public A visit (CONS<a> m);
}

